#include<avr/io.h>

//Definition von Taktfrequenz und Bausrate als Konstanten
#define TAKTFREQUENZ 9216000
#define BAUDRATE 115200

void initRS232()
{
   //Aktivieren der RS232-Schnittstelle des Mikrocontrollers:
    
    //Merken des in UBRR zu speichernden Wertes.
    unsigned int baudregister = TAKTFREQUENZ/8/BAUDRATE-1;

	//setzen der Baudrate
	UBRRH = (unsigned char) (baudregister>>8); //Setzen des HIGH-Bytes des Baudraten-Registers
	UBRRL = (unsigned char)  baudregister;     //Setzen des LOW -Bytes des Baudraten-Registers
	
	//Einschalten nur des Senders und des Empfngers
	UCSRB = (1<<TXEN) | (0<<RXEN);
		        
	//Setzen des Nachrichtenformats: 8 Datenbits, 1 Stopbits
	UCSRC = (1<<URSEL)|(1<<UCSZ0)|(1<<UCSZ1);
    UCSRA = (1<<U2X);
}

void senden(unsigned char zeichen, unsigned char empfaenger)
{
        while( !(UCSRA & (1<<UDRE)) ); //Warten bis der Uebertragungspuffer leer ist
        UDR = zeichen | empfaenger;    //Daten in den Puffer schreiben und bertragen
}

int main()
{
    unsigned char akku=0;
    unsigned long pause;

    DDRA = 0b00000000;
    DDRB = 0b00000000;
    DDRD = 0b00000000;

    DDRC = 0b11111111; //ber RS232 gesendete Zahlen sollen auch an 
                       //zweiten Mikrocontroller geschickt
                       //und angezeigt werden.

 
    initRS232();
    //Es soll wiederholt von 0 bis 255 durchgezhlt werden und
    //der aktuelle Wert im Hyperterminal zu sehen sein.

    PORTA = 0;

    while(1)
    {        

        senden(akku,0b00010000);
        PORTC = akku;
        for(pause=0;pause<100000;pause++);

        senden(9 - akku,0b00100000);
        PORTC = 9 - akku;
        for(pause=0;pause<100000;pause++);

        akku++;
        akku%=10;
    }
}
